/*
 * nxdrawlayer.cpp
 *
 *  Created on: Mar 21, 2012
 *      Author: dkaaser
 */

#include "nxdrawlayer.h"
#include "gl.h"
namespace nx {
nxDrawLayer::nxDrawLayer(const std::string& name, const colors::Color& color) :
		nxLayer(name), color(color), lineWidth(0.0) {
}

nxDrawLayer::~nxDrawLayer() {
	for (std::list<nxDrawable*>::iterator it = primitives.begin(); it != primitives.end(); ++it)
		delete *it;
	primitives.clear();
}

void nxDrawLayer::addPrimitive(nxDrawable *primitive) {
	primitives.push_back(primitive);
}
void nxDrawLayer::draw() {
	if (lineWidth > 0.0)
		glLineWidth(lineWidth);

	if (enabled && primitives.size() > 0) {
		color.set();
		for (std::list<nxDrawable*>::iterator it = primitives.begin(); it != primitives.end(); ++it)
			(*it)->draw();
	}
	nxLayer::draw();
	if (lineWidth > 0.0)
		glLineWidth(DEFAULT_LINE_WIDTH);
}
colors::Color& nxDrawLayer::getColor() {
	return color;
}
void nxDrawLayer::setLineWidth(const double lineWidth) {
	this->lineWidth = lineWidth;
}
}
