/*
 * nxlayer.cpp
 *
 *  Created on: Mar 21, 2012
 *      Author: dkaaser
 */

#include "nxlayer.h"

namespace nx {
using std::string;
nxLayer::nxLayer(const string& name) :
		name(name), toggleKey(-1), enabled(true) {
}
nxLayer::nxLayer(const string& name, const bool enabled) :
		name(name), toggleKey(-1), enabled(enabled) {
}

nxLayer::~nxLayer() {
	for (std::list<nxLayer*>::iterator it = layers.begin(); it != layers.end(); ++it)
		delete *it;
	layers.clear();
}

string nxLayer::getName() {
	return name;
}

void nxLayer::addLayer(nxLayer* layer) {
	layers.push_back(layer);
}

void nxLayer::draw() {
	if (enabled)
		for (std::list<nxLayer*>::iterator it = layers.begin(); it != layers.end(); ++it)
			(*it)->draw();
}

void nxLayer::key(int key) {
	this->key(key, 0, 0);
}

void nxLayer::key(int key, int x, int y) {
	for (std::list<nxLayer*>::iterator it = layers.begin(); it != layers.end(); ++it)
		(*it)->key(key, x, y);
	if (key == toggleKey)
		enabled = !enabled;
}

void nxLayer::setToggleKey(int key) {
	toggleKey = key;
}

void nxLayer::enable() {
	enabled = true;
}

void nxLayer::disable() {
	enabled = false;
}

}
