/*
 * nxlayer.h
 *
 *  Created on: Mar 21, 2012
 *      Author: dkaaser
 */

#ifndef NXLAYER_H_
#define NXLAYER_H_
#include <string>
#include <list>
#include "nxdrawable.h"
#include "color.h"
namespace nx {
class nxLayer: public nxDrawable {
public:
	nxLayer(const std::string& name);
	nxLayer(const std::string& name, const bool enabled);
	virtual ~nxLayer();
	virtual void draw();
	std::string getName();
	void addLayer(nxLayer* layer);

	void key(int key);
	virtual void key(int key, int x, int y);
	virtual void setToggleKey(int key);
	virtual void enable();
	virtual void disable();

protected:
	const std::string name;
	std::list<nxLayer*> layers;
	int toggleKey;
	bool enabled;
};
}
#endif /* NXLAYER_H_ */

