/*
 * nxlayer.cpp
 *
 *  Created on: Mar 21, 2012
 *      Author: dkaaser
 */

#include "nxtextlayer.h"

#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include "gl.h"
#include "nxwindow.h"
namespace nx {
using std::string;

nxTextLayer::nxTextLayer(const string& name, const colors::Color color) :
		nxLayer(name, false), color(color) {
}

nxTextLayer::~nxTextLayer() {
}

void nxTextLayer::draw() {
	if(!enabled)
		return;
	nxLayer::draw();
	color.set();
	for (std::list<std::pair<nxVector, std::string> >::iterator it = messages.begin(); it != messages.end(); ++it) {
		glRasterPos2d((*it).first.x, (*it).first.y);
		for (unsigned int i = 0; i < (*it).second.length(); ++i)
			glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, (*it).second[i]);
	}
}
void nxTextLayer::write(const nxVector position, const char* fmt, ...) {
	char text[1024];
	memset(text, 0, sizeof(char) * 1023);

	va_list ap;
	va_start(ap, fmt);
	vsnprintf(text, 1023, fmt, ap);
	va_end(ap);
	write(position, string(text));
}
void nxTextLayer::write(const nxVector position, const string text) {
	messages.push_back(std::pair<nxVector, string>(position, text));
}

}
