/*
 * line.cpp
 *
 *  Created on: Mar 21, 2012
 *      Author: dkaaser
 */

#include "arrow.h"
#include "line.h"
#include "../nxwindow.h"
#include "../nxdrawlayer.h"
#include "../gl.h"

namespace nx {

Arrow::Arrow(const nxVector& a, const nxVector& b) :
		a(a), b(b) {

}
void Arrow::draw() {
	const double size = (nxWindow::get()->getPixelLength()) * 4.0;
	if((a-b).length2() < size*size)
		return;
	const nxVector t = (b - a).norm() * size;
	const nxVector c = b - 2.0*t;
	const nxVector l = c + nxVector(t.y, -t.x);
	const nxVector r = c + nxVector(-t.y, t.x);

	double currentColor[4];
	glGetDoublev(GL_CURRENT_COLOR, currentColor);

	colors::white.set();
	glBegin(GL_TRIANGLES);
	glVertex2d(b.x, b.y);
	glVertex2d(l.x, l.y);
	glVertex2d(r.x, r.y);
	glEnd();
	colors::Color(currentColor[0], currentColor[1], currentColor[2], currentColor[3]).set();
	Line* line0 = new Line(a, c);
	Line* line1 = new Line(l, r);
	Line* line2 = new Line(r, b);
	Line* line3 = new Line(b, l);
	line0->draw();
	line1->draw();
	line2->draw();
	line3->draw();
	delete line0;
	delete line1;
	delete line2;
	delete line3;
}

Arrow::~Arrow() {

}

/*
 void Arrow::draw() {


 glBegin(GL_TRIANGLES);
 glVertex2d(tip.x, tip.y);
 glVertex2d(left.x, left.y);
 glVertex2d(right.x, right.y);
 glEnd();
 c.a = 0.8;
 c.set();
 glBegin(GL_LINE_STRIP);
 glVertex2d(left.x, left.y);
 glVertex2d(tip.x, tip.y);
 glVertex2d(right.x, right.y);
 glVertex2d(left.x, left.y);
 glEnd();
 glBegin(GL_LINE_STRIP);
 glVertex2d(x.x, x.y);
 glVertex2d((tip - 4.0 * base).x, (tip - 4.0 * base).y);
 glEnd();
 }*/

} /* namespace nx */
